--[[
	GemCensus: A gem popularity addon.
	Copyright (c) 2010 Cyprias <Cyprias@gmail.com>
	All Rights Reserved.
	Only Curse.com, WoWInterface.com & WoWace.com have permission to redistribute this software. 
	GemCensus shall not be included in a UI pack / compilation without permission. 
]]

local folder = "GemCensus_Display"
local core = LibStub("AceAddon-3.0"):GetAddon("GemCensus")
local display = core.display

local iLink = core.iLink
local UIParent = UIParent

local LPT = LibStub("LibPeriodicTable-3.1")
if not LPT then
	error(folder .. " requires LibPeriodicTable-3.1") 
	return
end

display.LPT = LPT

local GetItemInfo = GetItemInfo
local pairs = pairs

local rawGemNames = {}
display.cutToRaw = setmetatable({}, {
	__index = function(t,cutID)
	local cutName = GetItemInfo(cutID)
	for rawID, rawName in pairs(rawGemNames) do 
		if cutName:find(rawName) then
			t[cutID] = rawID
			return t[cutID]
		end
	end

	t[cutID] = false
	return t[cutID]
	end
})

function display:GetRawGems()--		/run _GCGem:GetRawGems()
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice
	for item, value, set in LPT:IterateSet("Tradeskill.Mat.ByProfession.Jewelcrafting") do
		itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(item)
		if itemType == "Gem" then
			rawGemNames[item] = itemName
		end
	end
end

local tooltip = CreateFrame("GameTooltip", folder.."ToolTip", UIParent, "GameTooltipTemplate")
local tooltipStats = _G[tooltip:GetName().."TextLeft2"]
tooltip:SetOwner(UIParent, "ANCHOR_NONE")

--Cache gem stats to a table. eg "+23 Spell Power"
display.gemStats = setmetatable({}, {
	__index = function(t,itemID)
		t[itemID] = "*"
		
		local gemLink = itemID and iLink[itemID]
		if gemLink then
			tooltip:SetOwner(UIParent, "ANCHOR_NONE")
			tooltip:ClearLines()
			tooltip:SetHyperlink(gemLink)
			
			local text = tooltipStats:GetText()
			if text and text:trim() ~= "" then
				t[itemID] = tooltipStats:GetText()
			end
		end
		return t[itemID]
	end
})